Dataset_image=double(Dataset);
copy=Dataset_image;% make a copy
Dataset_image=Dataset_image(:);	     	    % vectorize image (m*n) X (1) matrix
Image_minvalue=min(Dataset_image);          % deal with negative and zero values
Dataset_image=Dataset_image-Image_minvalue+1;	   
Ds_Length=length(Dataset_image);               
% create image histogram
Ds_max=max(Dataset_image)+1;
hist=zeros(1,Ds_max);  % histogram variable declaration
hc=zeros(1,Ds_max);
for i=1:Ds_Length
if(Dataset_image(i)>0)
hist(Dataset_image(i))=hist(Dataset_image(i))+1;
% here dataset value is hist(index)=increment
% for example 4 45 23 255 4 255 23 45 67 77 56
% Dataset(1)=4 and hist (4)=count increment.
end;
end
hist_index=find(hist); 
% here find eleminate the 0 value for example hist=1 5 2 6 3 7 4 8 4 9 0
% ind=find(hist) then the result be ind=1 2 3 4 5 6 7 8 9 here zero
% eliminated.
hist_length=length(hist_index);

% initiate centroids

Centroid=(1:k)*Ds_max/(k+1); %generate centroid 

% start process
ll=0;
while(true)
if sum(isnan(Centroid))>0	 % This if-command was added  to deal with NaN results

%Centroid

if Ds_max>k
Centroid = Ds_max * rand(1,k);
Centroid = sort(Centroid);
else
Centroid(:) = Ds_max-1;
break;
end

% disp('The initial centroids were produced randomly, because of calculating NaN amounts by K-means!!!')

end
old_Centroid=Centroid;

% current classification

for i=1:hist_length
Difffence=abs(hist_index(i)-Centroid);
cluster_position=find(Difffence==min(Difffence));
hist_clust(hist_index(i))=cluster_position(1);
end

%recalculation of means

for i=1:k,
Grouping=find(hist_clust==i);
Centroid(i)=sum(Grouping.*hist(Grouping))/sum(hist(Grouping));
end
if(Centroid==old_Centroid)
break;
end;
end
% calculate mask

s=size(copy);
mask=zeros(s);
for i=1:s(1),
for j=1:s(2),
c=abs(copy(i,j)-Centroid);
Grouping=find(c==min(c));
mask(i,j)=Grouping(1);
end
end
Centroid=Centroid+Image_minvalue-1; 		% recover real range
%figure;imshow(mask,[]);
